/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package se.softstuff.nb.nbtranslate.omegat;

import java.io.File;
import java.io.IOException;
import java.util.MissingResourceException;
import java.util.prefs.Preferences;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.NotifyDescriptor.Message;
import org.openide.awt.NotificationDisplayer;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.util.Exceptions;
import org.openide.util.ImageUtilities;
import org.openide.util.NbBundle;
import org.openide.util.NbPreferences;
import se.softstuff.nb.nbtranslate.data.NbTranslation;
import se.softstuff.nb.nbtranslate.data.NbTranslationDataObject;

/**
 *
 * @author Stefan
 */
public class OmegaTPanel extends javax.swing.JPanel {

    private static final String OMEGAT_HOME = "OmegaTHome";
    private static final String OMEGAT_PROJECT = "OmegaTProject";
    
    private NbTranslationDataObject translationFile;
    private NbTranslation translation;
    /**
     * Creates new form NewJPanel
     */
    public OmegaTPanel() {
        initComponents();
    }
    
    public void setTranslationFile(NbTranslationDataObject translationFile) {
        this.translationFile = translationFile;
        this.translation = translationFile.getContent();
        initOmegaT();
    }
    
     private void initOmegaT() {
        String prefix = translationFile.getPrimaryFile().getPath();
        Preferences pref = NbPreferences.forModule(OmegaTPanel.class);
        otHomeTextField.setText(pref.get(OMEGAT_HOME, ""));
        otProjTextField.setText(pref.get(prefix + OMEGAT_PROJECT, ""));
        fromLocaleComboBox.setModel(new TranslationComboBoxModel(translation));
    }
     
     private void export() throws MissingResourceException {
        try {
            String projHome = otProjTextField.getText();
            if (projHome  == null || projHome.isEmpty()) {
                Message message = new NotifyDescriptor.Message(org.openide.util.editable.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.noHomeProjectSet.dialogmessage"));
                DialogDisplayer.getDefault().notify(message);
                return ;
            }
            FileObject omegatProjectHome = FileUtil.toFileObject(new File(projHome));
            boolean removeOld = otClearOldCheckBox.isSelected();
            int rows = OmegaTExporter.export(translation, omegatProjectHome, removeOld, (String)fromLocaleComboBox.getSelectedItem());
            String title = org.openide.util.editable.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.export-balloon.title");
            String message = org.openide.util.editable.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.export-balloon.message", rows);
            ImageIcon icon = ImageUtilities.loadImageIcon("se/softstuff/nb/nbtranslate/manager/nb_translate.png", false);
            NotificationDisplayer.getDefault().notify(title, icon, message, null);
        }catch (IOException ex) {
           Exceptions.printStackTrace(ex);
       }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        omegatHomeLabel = new javax.swing.JLabel();
        otFindHomeButton = new javax.swing.JButton();
        otStartButton = new javax.swing.JButton();
        otHomeTextField = new javax.swing.JTextField();
        otProjTextField = new javax.swing.JTextField();
        otFindProjButton = new javax.swing.JButton();
        otClearOldCheckBox = new javax.swing.JCheckBox();
        otExportButton = new javax.swing.JButton();
        exportFilesStepLabel = new javax.swing.JLabel();
        updateOmegaTStepLabel = new javax.swing.JLabel();
        workInOmegaTStepLabel = new javax.swing.JLabel();
        saveTranslatedFilesStepLabel = new javax.swing.JLabel();
        importStepLabel = new javax.swing.JLabel();
        saveAndRetestApplicationStepLabel = new javax.swing.JLabel();
        otImportButton = new javax.swing.JButton();
        otProjLabel = new javax.swing.JLabel();
        createOmegaTProcectStepLabel = new javax.swing.JLabel();
        fromLocaleComboBox = new javax.swing.JComboBox();
        fromLocaleLabel = new javax.swing.JLabel();

        org.openide.awt.Mnemonics.setLocalizedText(omegatHomeLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.omegatHomeLabel.text")); // NOI18N
        omegatHomeLabel.setToolTipText(org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.omegatHomeLabel.toolTipText")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(otFindHomeButton, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otFindHomeButton.text")); // NOI18N
        otFindHomeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otFindHomeButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(otStartButton, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otStartButton.text")); // NOI18N
        otStartButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otStartButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(otFindProjButton, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otFindProjButton.text")); // NOI18N
        otFindProjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otFindProjButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(otClearOldCheckBox, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otClearOldCheckBox.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(otExportButton, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otExportButton.text")); // NOI18N
        otExportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otExportButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(exportFilesStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.exportFilesStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(updateOmegaTStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.updateOmegaTStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(workInOmegaTStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.workInOmegaTStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(saveTranslatedFilesStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.saveTranslatedFilesStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(importStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.importStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(saveAndRetestApplicationStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.saveAndRetestApplicationStepLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(otImportButton, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otImportButton.text")); // NOI18N
        otImportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otImportButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(otProjLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otProjLabel.text")); // NOI18N
        otProjLabel.setToolTipText(org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.otProjLabel.toolTipText")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(createOmegaTProcectStepLabel, org.openide.util.NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.createOmegaTProcectStepLabel.text")); // NOI18N

        fromLocaleComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Loading--" }));

        org.openide.awt.Mnemonics.setLocalizedText(fromLocaleLabel, NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.fromLocaleLabel.text")); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(saveAndRetestApplicationStepLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 372, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(importStepLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 632, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(createOmegaTProcectStepLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 527, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(omegatHomeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 274, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(otProjLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 274, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(23, 23, 23)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(fromLocaleLabel)
                                        .addGap(18, 18, 18)
                                        .addComponent(fromLocaleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(otClearOldCheckBox))
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(otProjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(otHomeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addComponent(updateOmegaTStepLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 304, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(saveTranslatedFilesStepLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(workInOmegaTStepLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(exportFilesStepLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 348, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(otFindProjButton)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(otFindHomeButton)
                                .addGap(18, 18, 18)
                                .addComponent(otStartButton))
                            .addComponent(otExportButton)
                            .addComponent(otImportButton))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(otHomeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(omegatHomeLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(createOmegaTProcectStepLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(otProjLabel)
                            .addComponent(otProjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(exportFilesStepLabel)
                            .addComponent(fromLocaleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(fromLocaleLabel)
                            .addComponent(otClearOldCheckBox))
                        .addGap(10, 10, 10)
                        .addComponent(updateOmegaTStepLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(workInOmegaTStepLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(saveTranslatedFilesStepLabel)
                        .addGap(11, 11, 11)
                        .addComponent(importStepLabel))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(otFindHomeButton)
                            .addComponent(otStartButton))
                        .addGap(26, 26, 26)
                        .addComponent(otFindProjButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(otExportButton)
                        .addGap(71, 71, 71)
                        .addComponent(otImportButton)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(saveAndRetestApplicationStepLabel)
                .addContainerGap(20, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void otFindHomeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otFindHomeButtonActionPerformed
        String dir = otHomeTextField.getText().trim();

        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setDialogTitle(NbBundle.getMessage(getClass(), "OmegaTPanel.otFindHome.Dialog.title"));
        if (!dir.isEmpty()) {
            fileChooser.setCurrentDirectory(new File(dir));
        }

        int returnVal = fileChooser.showOpenDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {

            String newDir = fileChooser.getSelectedFile().getAbsolutePath();
            Preferences pref = NbPreferences.forModule(OmegaTPanel.class);
            pref.put(OMEGAT_HOME, newDir);
            otHomeTextField.setText(newDir);
        }
    }//GEN-LAST:event_otFindHomeButtonActionPerformed

    private void otStartButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otStartButtonActionPerformed
        try {
            String dir = otHomeTextField.getText().trim();
            StringBuilder command = new StringBuilder();
            command.append("java -jar ");
            command.append("-Xmx512M ");
            command.append(dir).append(File.separator).append("OmegaT.jar ");
            command.append("%*");

            Process process = Runtime.getRuntime().exec(command.toString());

            // any error messages?
            StreamCatcher errorCatcher = new StreamCatcher(process.getErrorStream());

            // any output?
            StreamCatcher outputCatcher = new StreamCatcher(process.getInputStream());

            // kick them off
            errorCatcher.start();
            outputCatcher.start();

        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_otStartButtonActionPerformed

    private void otFindProjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otFindProjButtonActionPerformed
        String dir = otProjTextField.getText().trim();

        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setDialogTitle(NbBundle.getMessage(getClass(), "OmegaTPanel.otFindDir.Dialog.title"));
        if (!dir.isEmpty()) {
            fileChooser.setCurrentDirectory(new File(dir));
        }

        int returnVal = fileChooser.showOpenDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {

            String newDir = fileChooser.getSelectedFile().getAbsolutePath();
            String prefix = translationFile.getPrimaryFile().getPath();
            Preferences pref = NbPreferences.forModule(OmegaTPanel.class);
            pref.put(prefix + OMEGAT_PROJECT, newDir);
            otProjTextField.setText(newDir);
        }
    }//GEN-LAST:event_otFindProjButtonActionPerformed

    private void otExportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otExportButtonActionPerformed
        export();
    }//GEN-LAST:event_otExportButtonActionPerformed

    private void otImportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otImportButtonActionPerformed

        try {
            String projHome = otProjTextField.getText();

            if(projHome  == null || projHome.isEmpty()){
                Message message = new NotifyDescriptor.Message(NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.noHomeProjectSet.dialogmessage"));
                DialogDisplayer.getDefault().notify(message);
                return;
            }

            FileObject f = FileUtil.toFileObject(new File(projHome));
            NbTranslation translation = translationFile.getContent();
            int rowsUpdated = OmegaTUtility.importChanges(translation, f);
            String title = NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.import-balloon.title");
            String message = NbBundle.getMessage(OmegaTPanel.class, "OmegaTPanel.import-balloon.message", rowsUpdated);

            ImageIcon icon = ImageUtilities.loadImageIcon("se/softstuff/nb/nbtranslate/manager/nb_translate.png", false);
            NotificationDisplayer.getDefault().notify(title, icon, message, null);

        } catch (Exception ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_otImportButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel createOmegaTProcectStepLabel;
    private javax.swing.JLabel exportFilesStepLabel;
    private javax.swing.JComboBox fromLocaleComboBox;
    private javax.swing.JLabel fromLocaleLabel;
    private javax.swing.JLabel importStepLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel omegatHomeLabel;
    private javax.swing.JCheckBox otClearOldCheckBox;
    private javax.swing.JButton otExportButton;
    private javax.swing.JButton otFindHomeButton;
    private javax.swing.JButton otFindProjButton;
    private javax.swing.JTextField otHomeTextField;
    private javax.swing.JButton otImportButton;
    private javax.swing.JLabel otProjLabel;
    private javax.swing.JTextField otProjTextField;
    private javax.swing.JButton otStartButton;
    private javax.swing.JLabel saveAndRetestApplicationStepLabel;
    private javax.swing.JLabel saveTranslatedFilesStepLabel;
    private javax.swing.JLabel updateOmegaTStepLabel;
    private javax.swing.JLabel workInOmegaTStepLabel;
    // End of variables declaration//GEN-END:variables
}
